Index: tmp/org.txm.referencer.rcp/src/org/txm/referencer/rcp/editors/ReferencerEditor.java
===================================================================
--- tmp/org.txm.referencer.rcp/src/org/txm/referencer/rcp/editors/ReferencerEditor.java	(revision 722)
+++ tmp/org.txm.referencer.rcp/src/org/txm/referencer/rcp/editors/ReferencerEditor.java	(revision 723)
@@ -34,8 +34,6 @@
 import org.eclipse.jface.viewers.TableViewer;
 import org.eclipse.osgi.util.NLS;
 import org.eclipse.swt.SWT;
-import org.eclipse.swt.events.KeyEvent;
-import org.eclipse.swt.events.KeyListener;
 import org.eclipse.swt.events.MouseAdapter;
 import org.eclipse.swt.events.MouseEvent;
 import org.eclipse.swt.events.SelectionEvent;
@@ -49,33 +47,28 @@
 import org.eclipse.swt.widgets.Composite;
 import org.eclipse.swt.widgets.Display;
 import org.eclipse.swt.widgets.TableColumn;
-import org.eclipse.ui.IEditorInput;
-import org.eclipse.ui.IEditorSite;
-import org.eclipse.ui.PartInitException;
 import org.txm.core.messages.TXMCoreMessages;
-import org.txm.core.preferences.TXMPreferences;
-import org.txm.core.results.TXMResult;
+import org.txm.core.results.Parameter;
 import org.txm.rcp.StatusLine;
 import org.txm.rcp.editors.TXMEditor;
-import org.txm.rcp.editors.TXMResultEditorInput;
 import org.txm.rcp.editors.TableKeyListener;
+import org.txm.rcp.editors.listeners.ComputeKeyListener;
+import org.txm.rcp.editors.listeners.ComputeSelectionListener;
 import org.txm.rcp.messages.TXMUIMessages;
-import org.txm.rcp.preferences.RCPPreferences;
 import org.txm.rcp.swt.GLComposite;
 import org.txm.rcp.swt.widget.NavigationWidget;
 import org.txm.rcp.swt.widget.PropertiesSelector;
 import org.txm.rcp.swt.widget.QueryWidget;
 import org.txm.rcp.views.QueriesView;
-import org.txm.rcp.views.corpora.CorporaView;
 import org.txm.referencer.core.functions.Referencer;
 import org.txm.referencer.core.functions.Referencer.Line;
+import org.txm.referencer.core.preferences.ReferencerPreferences;
 import org.txm.referencer.rcp.handlers.ReferencerToConc;
 import org.txm.referencer.rcp.messages.ReferencerUIMessages;
 import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
 import org.txm.searchengine.cqp.corpus.Corpus;
 import org.txm.searchengine.cqp.corpus.Property;
 import org.txm.searchengine.cqp.corpus.StructuralUnitProperty;
-import org.txm.searchengine.cqp.corpus.query.Query;
 import org.txm.statsengine.r.rcp.views.RVariablesView;
 
 /**
@@ -92,15 +85,7 @@
 	/** The referencer. */
 	Referencer referencer;
 
-	/** The querywidget. */
-	QueryWidget querywidget;
 	
-	/** The props area. */
-	protected PropertiesSelector<Property> propsArea;
-	
-	/** The pattern area. */
-	protected PropertiesSelector<StructuralUnitProperty> patternArea;
-	
 	/** The navigation area. */
 	NavigationWidget navigationArea;
 
@@ -133,121 +118,52 @@
 	/** The mess. */
 	String mess;
 
-	
-	@Override
-	public void init(IEditorSite site, IEditorInput input)
-	throws PartInitException {
-		setSite(site);
-		setInput(input);
 
-		if (!(input instanceof TXMResultEditorInput)) {
-			throw new PartInitException("Editor input is not a TXMResultEditorInput input editor: "+input);
-		}
-		
-		TXMResult result = ((TXMResultEditorInput) input).getResult();
-		
-		if (!(result instanceof Referencer)) {
-			throw new PartInitException("TXMResult input is not a Referencer result: "+result);
-		}
-		
-		this.referencer = ((Referencer) result);
-		this.corpus = referencer.getCorpus();
-		
-	}
-
 	
+	/** The querywidget. */
+	@Parameter(key=ReferencerPreferences.QUERY)
+	protected QueryWidget querywidget;
+	
 	/**
-	 * Compute.
-	 *
-	 * @return true, if successful
+	 * Word property selector.
 	 */
-	@Override
-	public void updateEditorFromResult(boolean update) {
-		
-//		JobHandler jobhandler = new JobHandler("refreshing...") {
-//			@Override
-//			protected IStatus run(IProgressMonitor monitor) {
-//				this.runInit(monitor);
-//				try {
-//					JobsTimer.start();
-//									
-//					monitor.worked(50);
-//
-//					monitor.subTask(RCPMessages.ReferencerEditor_13);
-//					syncExec(new Runnable() {
-//						@Override
-//						public void run() {
-							fillDisplayArea(0, lineperpage);
-							CorporaView.refresh();
-							CorporaView.expand(corpus);
-							QueriesView.refresh();
-							RVariablesView.refresh();
-							//setPartName(referencer.getName()); //$NON-NLS-1$
-							
-							viewer.getTable().setFocus();
-							System.out.println(NLS.bind(TXMUIMessages.CreatePartition_5, referencer.getNLines(), referencer.getV()));
-//						}
-//					});
-//
-//					monitor.worked(100);
-//				} catch (ThreadDeath td) {
-//					return Status.CANCEL_STATUS;
-//				} catch (Exception e) {
-//					org.txm.rcp.utils.Logger.printStackTrace(e);
-//				} finally {
-//					monitor.done();
-//					JobsTimer.stopAndPrint();
-//				}
-//				return Status.OK_STATUS;
-//			}
-//		};
-//		jobhandler.startJob();
+	@Parameter(key=ReferencerPreferences.UNIT_PROPERTY)
+	protected PropertiesSelector<Property> propertiesSelector;
+	
+	/** The pattern area. */
+	@Parameter(key=ReferencerPreferences.PATTERN)
+	protected PropertiesSelector<StructuralUnitProperty> patternArea;
 
-		return;
-	}
+	
 
-	/* (non-Javadoc)
-	 * @see org.eclipse.ui.part.WorkbenchPart#createPartControl(org.eclipse.swt.widgets.Composite)
-	 */
+	
 	@Override
 	public void _createPartControl(Composite parent) {
-//		super.createPartControl(parent);
 		
+		
+		this.referencer = ((Referencer) this.getResult());
+		this.corpus = referencer.getCorpus();
+
+		// Computing listener
+		ComputeSelectionListener computeSelectionListener = new ComputeSelectionListener(this);
+		ComputeKeyListener computeKeyListener = new ComputeKeyListener(this);
+
+		
 		parent.setLayout(new GridLayout(1,true));
 		Composite paramArea = getCommandParametersGroup();
 		paramArea.setLayout(new GridLayout(3, false));
 		
 		querywidget = new QueryWidget(paramArea, SWT.None);
 		querywidget.setLayoutData(new GridData(GridData.FILL, GridData.CENTER, true, false));
-		querywidget.addKeyListener(new KeyListener() {
-			@Override
-			public void keyReleased(KeyEvent e) { }
+		querywidget.addKeyListener(computeKeyListener);
 
-			@Override
-			public void keyPressed(KeyEvent e) {
-				if (e.keyCode == SWT.CR || e.keyCode == SWT.KEYPAD_CR) {
-					referencer.setQuery(querywidget.getQuery());
-					compute(true);
-				}
-			}
-		});
-
 		// [Edit]
-		propsArea = new PropertiesSelector<Property>(paramArea, SWT.NONE);
-		propsArea.setMaxPropertyNumber(1);
-		propsArea.setLayoutData(new GridData(GridData.FILL, GridData.FILL,
+		propertiesSelector = new PropertiesSelector<Property>(paramArea, SWT.NONE);
+		propertiesSelector.setMaxPropertyNumber(1);
+		propertiesSelector.setLayoutData(new GridData(GridData.FILL, GridData.FILL,
 				false, false));
-		propsArea.setLayout(new GridLayout(3, false));
-		propsArea.addSelectionListener(new SelectionListener() {
-			@Override
-			public void widgetSelected(SelectionEvent e) {
-				referencer.setProperty(propsArea.getSelectedProperties().get(0));
-				compute(true);
-			}
-			
-			@Override
-			public void widgetDefaultSelected(SelectionEvent e) { }
-		});
+		propertiesSelector.setLayout(new GridLayout(3, false));
+		propertiesSelector.addSelectionListener(computeSelectionListener);
 		
 		// [Search]
 		Button go = new Button(paramArea, SWT.PUSH);
@@ -261,33 +177,17 @@
 		go.setFont(newf);
 
 		go.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, false, false));
-		go.addSelectionListener(new SelectionListener() {
-			@Override
-			public void widgetSelected(SelectionEvent e) {
-				updateResultFromEditor();
-				compute(true);
-			}
+		go.addSelectionListener(computeSelectionListener);
 
-			@Override
-			public void widgetDefaultSelected(SelectionEvent e) { }
-		});
-
 		// [pattern : ... ]
 		patternArea = new PropertiesSelector<StructuralUnitProperty>(paramArea, SWT.NONE);
 		patternArea.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false,3,1));
 		patternArea.setLayout(new GridLayout(3, false));
 		patternArea.setText(ReferencerUIMessages.ReferencerEditor_6);
-		patternArea.addSelectionListener(new SelectionListener() {
-			@Override
-			public void widgetSelected(SelectionEvent e) {
-				referencer.setPattern(patternArea.getSelectedProperties());
-				compute(true);
-			}
-			
-			@Override
-			public void widgetDefaultSelected(SelectionEvent e) { }
-		});
+		patternArea.addSelectionListener(computeSelectionListener);
 
+		
+		
 		//pagination
 		GLComposite navigationComposite = getBottomToolbar().installGLComposite("navigation", 1, false);
 		navigationArea = new NavigationWidget(navigationComposite, SWT.None);
@@ -401,43 +301,34 @@
 		unitColumn.setText(TXMCoreMessages.common_units);
 		unitColumn.setToolTipText(TXMCoreMessages.common_units);
 		unitColumn.setWidth(200);
-		unitColumn.addSelectionListener(new SelectionListener() {
-			@Override
-			public void widgetSelected(SelectionEvent e) {
 
-			}
-
-			@Override
-			public void widgetDefaultSelected(SelectionEvent e) {
-			}
-		});
-
 		freqColumn = new TableColumn(viewer.getTable(), SWT.LEFT);
 		freqColumn.setText(ReferencerUIMessages.ReferencerEditor_11);
 		freqColumn.setToolTipText(ReferencerUIMessages.ReferencerEditor_11);
 		freqColumn.setWidth(100);
-		freqColumn.addSelectionListener(new SelectionListener() {
-			@Override
-			public void widgetSelected(SelectionEvent e) {
-
-			}
-
-			@Override
-			public void widgetDefaultSelected(SelectionEvent e) {
-			}
-		});
 		
 		initializeFields();
 		
 		
 		// Register the context menu
-		TXMEditor.initContextMenu(this.viewer.getTable(), "ReferencerEditorContextMenu", this.getSite(), this.viewer); // $NON-NLS-1$
+		TXMEditor.initContextMenu(this.viewer.getTable(), this.getSite(), this.viewer); // $NON-NLS-1$
 
 		
 	}
 	
+	@Override
+	public void updateEditorFromResult(boolean update) {
 
+		fillDisplayArea(0, lineperpage);
+		QueriesView.refresh();
+		RVariablesView.refresh();
 
+		viewer.getTable().setFocus();
+		System.out.println(NLS.bind(TXMUIMessages.CreatePartition_5, referencer.getNLines(), referencer.getV()));
+	}
+
+
+
 	/**
 	 * Send selection to conc.
 	 */
@@ -542,6 +433,9 @@
 		return this.corpus;
 	}
 
+	/**
+	 * 
+	 */
 	protected void initializeFields() {
 		// word properties
 		try {
@@ -552,9 +446,9 @@
 			if (referencer.getProperty() != null) {
 				selectedProps.add(referencer.getProperty());
 				availables.remove(referencer.getProperty());
-				this.propsArea.setProperties(availables, selectedProps);
+				this.propertiesSelector.setProperties(availables, selectedProps);
 			} else {
-				this.propsArea.setCorpus(corpus);
+				this.propertiesSelector.setCorpus(corpus);
 			}
 			
 		} catch (CqiClientException e1) {
@@ -581,19 +475,10 @@
 			org.txm.rcp.utils.Logger.printStackTrace(e1);
 			return;
 		}
-		
-		if (referencer.getQuery() != null) {
-			this.querywidget.setText(referencer.getQuery().getQueryString());
-		}
 	}
 
 	@Override
 	public void updateResultFromEditor() {
-		final Query query = querywidget.getQuery();
-		final List<Property> queryprops = propsArea.getSelectedProperties();
-		final List<StructuralUnitProperty> refs = patternArea.getSelectedProperties();
-		boolean hierarchicSort = TXMPreferences.getBoolean(RCPPreferences.SORTBYFREQ, RCPPreferences.PREFERENCES_NODE);
-		
-		referencer.setParameters(query, queryprops.get(0), refs, hierarchicSort);
+		// nothing to do
 	}
 }
Index: tmp/org.txm.referencer.rcp/src/org/txm/referencer/rcp/preferences/ReferencerPreferencePage.java
===================================================================
--- tmp/org.txm.referencer.rcp/src/org/txm/referencer/rcp/preferences/ReferencerPreferencePage.java	(revision 722)
+++ tmp/org.txm.referencer.rcp/src/org/txm/referencer/rcp/preferences/ReferencerPreferencePage.java	(revision 723)
@@ -28,45 +28,35 @@
 package org.txm.referencer.rcp.preferences;
 
 import org.eclipse.jface.preference.BooleanFieldEditor;
-import org.txm.rcp.preferences.RCPPreferences;
-import org.txm.rcp.preferences.RCPPreferencesPage;
+import org.eclipse.ui.IWorkbench;
+import org.txm.rcp.preferences.TXMPreferencePage;
+import org.txm.rcp.preferences.TXMPreferenceStore;
+import org.txm.referencer.core.preferences.ReferencerPreferences;
 import org.txm.referencer.rcp.messages.ReferencerUIMessages;
 
+
 /**
- * This class represents a preference page that is contributed to the
- * Preferences dialog. By subclassing <samp>FieldEditorPreferencePage</samp>, we
- * can use the field support built into JFace that allows us to create a page
- * that is small and knows how to save, restore and apply itself.
- * <p>
- * This page is used to modif y preferences only. They are stored in the
- * preference store that belongs to the main plug-in class. That way,
- * preferences can be accessed directly via the preference store.
+ * Referencer preference page.
+ * 
+ * @author mdecorde
+ * @author sjacquot
+ *
  */
+public class ReferencerPreferencePage extends TXMPreferencePage {
 
-public class ReferencerPreferencePage extends RCPPreferencesPage {
 
-	/** The referencer_sorttype. */
-	private BooleanFieldEditor referencer_sorttype;
-
-	/**
-	 * Instantiates a new referencer preference page.
-	 */
-	public ReferencerPreferencePage() {
-		super();
-		setTitle(ReferencerUIMessages.ReferencerPreferencePage_2);
-	}
-
-	/**
-	 * Creates the field editors. Field editors are abstractions of the common
-	 * GUI blocks needed to manipulate various types of preferences. Each field
-	 * editor knows how to save and restore itself.
-	 */
+	
 	@Override
 	public void createFieldEditors() {
+		this.addField(new BooleanFieldEditor(ReferencerPreferences.SORT_BY_FREQUENCIES, ReferencerUIMessages.ReferencerPreferencePage_3, this.getFieldEditorParent()));
+	}
 
-		referencer_sorttype = new BooleanFieldEditor(RCPPreferences.SORTBYFREQ, ReferencerUIMessages.ReferencerPreferencePage_3, getFieldEditorParent());
-		
-		addField(referencer_sorttype);
-
+	@Override
+	public void init(IWorkbench workbench) {
+		this.setPreferenceStore(new TXMPreferenceStore(ReferencerPreferences.PREFERENCES_NODE));
+		this.setTitle(ReferencerUIMessages.ReferencerPreferencePage_2);
 	}
+	
+	
+	
 }
